# phrasestream

Phrasestream is a library for detecting phrases or prefixes and then
manipulating them.

The implementation exposes an `io.Writer`, detection works across write
boundaries and uses a radix tree for efficient searching.

Phrasestream is useful for secret detection and masking, as well as
handling control keywords in an output stream.

The subpackage `addmask` provides a good example of how this library can
be used. It implements behaviour similar to GitHub's `::add-mask::` action
runner functionality, with a few changes:

- Really long output lines don't slow down processing (https://github.com/actions/runner/issues/1031)
- Multi-line secrets are supported (https://github.com/actions/runner/issues/161).

  This is a deviation from GitHub's implementation, but is argubly safer.
- Powershell error output handling is not currently implemented.
